const PUC_GUID = "{48998E1D-262B-47cb-9D9F-02D1906F1561}";
const PUC_CONFIG_NAME = "pucconfig.xml";
const PUC_DEFAULT_CONFIG_NAME = "defaultpucconfig.xml"
const PUC_VERSION = "0.2";

// Thanks to RIP's Jerome O'Flaherty, whose code I used substantially


// Forgive me for what is probably very inconsistent tabbing...I did most of this in notepad --Carl

function pucPage() {
	this.id = null;
	this.title = "";
	this.url = null;
	this.enabled = false;
	this.period = 0;
	this.units = "seconds";
	this.checkAtStartup = false;
	this.timer = null;
}

var pucCache;
var pucIWatchPages = false;


function puc_init () {

	window.removeEventListener("load", puc_init, true);

	// First, see if anyone else already is monitoring pages:
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var enumerator = wm.getEnumerator("navigator:browser");
	while(enumerator.hasMoreElements()) {
		var win = enumerator.getNext();
		if(win.pucIWatchPages)
			return; // We don't need to bother doing anything
	}

	pucIWatchPages = true;
	pucCheckPreferences();

	pucCache = pucLoadConfiguration(pucCache);

	puc_startAllTimers(true);

}


// This will be called by the controlling window if they close to a single
// remaining window so that we may take over control
// The only gross part about this is that the timers are restarted
function pucTakeOverWatch(newCache)
{
	// It seems that destroy is called multiple times, and not always when we want it to be
	if(!pucIWatchPages) {
		pucIWatchPages = true;
		puc_logMessage("Taking over control");
		pucIWatchPages = true;
		pucCheckPreferences();
		pucCache = newCache;
		puc_startAllTimers(false);
	}
}


function puc_destroy()
{

	// Can't do this, it is unloading for some reason while it is loading!
	// window.removeEventListener("unload", puc_destroy, true); 

	if(pucIWatchPages) {
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var enumerator = wm.getEnumerator("navigator:browser");

		// If any BROSWER WINDOWS still exists
		if(enumerator.hasMoreElements()) {

			var win = enumerator.getNext();

			// Make sure we're not seeing ourself
			if(win == window)
				if(enumerator.hasMoreElements())
					win = enumerator.getNext();
				else
					return; // We were just seeing ourselves and no one is left, let firefox kill everything

			win.pucTakeOverWatch(pucCache);
		}
	}
}


function pucCheckPreferences()
{
      pucSetDefaultPref("puc.notifydespiteupdate", Components.interfaces.nsIPrefBranch.PREF_BOOL, false);
      pucSetDefaultPref("puc.alertonfailure", Components.interfaces.nsIPrefBranch.PREF_BOOL, true);
}


// If we don't have any defaults set then create them with the appropriate values!
function pucSetDefaultPref(prefName, prefType, value)
{
      var prefToSet = PrefUtils.getPref(prefName);
      if (prefToSet == null)
      {
          PrefUtils.setPrefWithType(prefName, prefType, value);
      }
}


function pucLoadConfiguration(cache) {
	try {
		istream = puc_getReadStream(PUC_CONFIG_NAME);
	} catch(ex) { 
		try {
			// We've never saved before, load the default configuration
			istream = puc_getReadStream(PUC_DEFAULT_CONFIG_NAME);
		} catch(exc) {
			puc_logMessage("Error: No configuration file found, cannot initialize Page Update Checker.");
			alert("PUC Installation corrupted, please reinstall");
			return;
		}
	}
	
	cache = puc_checkCache(cache);

	return puc_loadStream(cache, istream);
	
}


function puc_startAllTimers(checkNow)
{
	for(var i = 0; i < pucCache.length; i++) {
		if(pucCache[i].enabled) {
			puc_startTimer(pucCache[i]);
			if(pucCache[i].checkAtStartup && checkNow)
				puc_checkForUpdate(pucCache[i].id, false);
		}
	}
}


function puc_startTimer(page) {

	// Don't start a timer twice, so kill old running timers:
	if(page.timer != null)
		puc_stopTimer(page.timer);

	if(page.enabled) {
		var unitsToMilliseconds;
		switch(page.units) {
			case("seconds"):
				unitsToMilliseconds = 1000;
				break;
			case("minutes"):
				unitsToMilliseconds = 1000 * 60;
				break;
			case("hours"):
				unitsToMilliseconds = 1000 * 60 * 60;
				break;
			default:
				unitsToMilliseconds = 1000 * 60;
				puc_logMessage("Unit type " + page.units + " not recognized, defaulted to minutes.");
				break;
		}
		var interval = Math.round(page.period * unitsToMilliseconds);
		page.timer = setInterval("puc_checkForUpdate('"+ page.id + "', false)", interval);
		puc_logMessage("Started timer # " + page.timer + " for " + page.title + ": " + page.url + " at intervals of " + interval + " milliseconds");
	} 
}


function puc_stopTimer(timer) {
    puc_logMessage("Timer # " + timer + " halted");
    clearInterval(timer);
}


function puc_getReadStream (fileName) {
        var file =  puc_getFile(fileName);
        return puc_getStream(file);
}


function puc_getStream(theFile) {
        var stream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
        stream.init(theFile, 0x01 , 00004, null);
        var sInputStream = Components.classes["@mozilla.org/network/buffered-input-stream;1"].createInstance(Components.interfaces.nsIBufferedInputStream);
        sInputStream.init(stream, 1000);
        return sInputStream;
}


function puc_getWriteStream(fileName) {
        var file = puc_getFile(fileName);
        var stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
        stream.init(file, 0x02 | 0x08 | 0x20, 420, 0);
        return stream;
}


function puc_getFile(fileName) {
	var file = puc_getDir();
        file.append(fileName);
        return file;
}


function puc_getDir() {
        var file = Components.classes["@mozilla.org/file/directory_service;1"]
                                .getService(Components.interfaces.nsIProperties)
                                .get("ProfD", Components.interfaces.nsILocalFile);

	file.append("extensions");
        file.append(PUC_GUID);
        file.append("store"); // Notice we store everything, cache files and configuration in the store directoy

        return file;
}


// This is legacy and probably no longer necessary
function puc_checkCache(cache) {
       if (cache == null)
       {
          cache = new Array();
       }
       return cache;
}


function puc_loadStream(pucCacheToLoad, istream) {
     var doc = null;
     var parser = new DOMParser();

    // When I (Carl) tested this on Firefox 0.9 on my coLinux debian box, it NEEDED this try-catch.
    // Aparently the XML parser doesn't exist on it? I probably just installed Firefox wrong.
    try 
    {
        doc = parser.parseFromStream(istream, null, istream.available(), "text/xml");
	
        var pXPE = new XPathEvaluator();
        var nodes = pXPE.evaluate("/", doc, null, 0, null);

        var configVer = doc.firstChild.getAttribute("version");
        if (configVer > PUC_VERSION)
        {
            alert("Page Update Checker: Config file has more recent version ("+
	    	configVer+"), than current version of PUC (" + PUC_VERSION + ")");
	    puc_logMessage("Version mismatch");
            return null;
        }

        if (nodes != null)
        {
            for (var node = null; (node = nodes.iterateNext()); )
            {
                var configs = 0;
                var configNode = null;

                for(; (configNode = node.childNodes[configs]); configs++)
                {
                    var pages = 0;
                    var pageNode = null;

                    for(; (pageNode = configNode.childNodes[pages]); pages++)
                    {
                        if (pageNode.nodeName == "page")
                        {
                            var page = new pucPage();
                            page.id = pageNode.getAttributeNode("id").value;
                            page.title = pageNode.getAttributeNode("title").value;
                            page.url = pageNode.getAttributeNode("url").value;
			    page.period = pageNode.getAttributeNode("period").value;
                            page.enabled = (pageNode.getAttribute("enabled") == "true");
                            page.units = pageNode.getAttributeNode("units").value;
			    page.checkAtStartup = (pageNode.getAttribute("checkAtStartup") == "true");

                            // We rely on Javascript to resize the array.
			    // We also assume that id will always be a reasonable
			    // number.
			    pucCacheToLoad.push(page);
                        }
                    }
                }
            }
        }
     }
     catch (e)
     {
       puc_logMessage(e + "\nThis Probably means that you will not be able to save your settings when you close firefox.");
     }
     istream.close();

     return pucCacheToLoad;
}


function setPucCache(updatedCache)
{
       pucCache = updatedCache;
}


function puc_save()
    {
        puc_checkCache();

        try
        {
            var doc = document.implementation.createDocument("", "pucconfig", null);

            for (var i = 0; i < pucCache.length; i++)
            {
                var pageObj = pucCache[i];
                if (pageObj != null)
                {
                    var pageNode = puc_createPageNode(doc, pageObj);

                    doc.firstChild.appendChild(doc.createTextNode("\n\t"));
                    doc.firstChild.appendChild(pageNode);
                }
            }

            doc.firstChild.appendChild(doc.createTextNode("\n"));
            doc.firstChild.setAttribute("version", PUC_VERSION);

            var configStream = puc_getWriteStream(PUC_CONFIG_NAME);
            new XMLSerializer().serializeToStream(doc, configStream, "utf-8");
            configStream.close();
        }
        catch (e)
        {
           puc_logMessage("Error during save: " + e);
        }
}


function puc_createPageNode(doc, pageObj) {
        var pageNode = doc.createElement("page");

        pageNode.appendChild(doc.createTextNode("\n\t"));

        pageNode.setAttribute("id", pageObj.id);
        pageNode.setAttribute("title", pageObj.title);
        pageNode.setAttribute("url", pageObj.url);
        pageNode.setAttribute("enabled", pageObj.enabled);
	pageNode.setAttribute("period", pageObj.period);
	pageNode.setAttribute("units", pageObj.units);
	pageNode.setAttribute("checkAtStartup", pageObj.checkAtStartup);
        return pageNode;
}


// This allows for the asynchronous http grabbing command checkForUpdate
// to be called from options just as it is closing.
function puc_checkForUpdateDelayed(id, firstTime) {
	setTimeout("puc_checkForUpdate(" + id + ", " + firstTime + ")", 200);
}


// Downloads a webpage, if it is the first time, it just saves the file.
// if !firstTime then it will go ahead and compare the two and alert the
// user if the file has changed
function puc_checkForUpdate(id, firstTime) {

        var page = new pucPage();

	// Find the page corresponding to this ID
        for(var i = 0; i < pucCache.length; i++)
            if(pucCache[i].id == id)
                 page = pucCache[i];

	// We use XMLHttpRequest which can actually get us the raw "text" for anything, including
	// pages, pictures, etc. 
        var req = new XMLHttpRequest();
	
	// We have to embed the funciton so that it has easy access to our page
	// This avoids problems with simultaneous update checks while still downloading
	// in the background, not holding up the UI

	req.onreadystatechange = 

		function () 
		{
			if (req.readyState != 4) {
	                    // Do Nothing -- We haven't finished downloading
			} else if (req.status != 200) { 
				puc_logMessage("Page Update Checker: There was a problem downloading the webpage " + page.url + " to compare.");
				if(PrefUtils.getPref("puc.alertonfailure"))
					alert("Page Update Checker: There was a problem downloading the webpage " + page.url + " to compare.\n"+
						"To remove this message, go to Preferences in the Page Update Checker extension options");
				
			} else if(firstTime) {
				// Simply write the file
				puc_logMessage("Saving html from id " + page.id + " " + page.url + " for the first time");
				puc_writeBasedOnID(req.responseText, page.id);
			} else {
				// Request a comparrison
				puc_compareOldWithNew(page, req.responseText);
       	         	}
       		}


	puc_logMessage("Downloading id " + id + ": " + page.url + " for update check");
        req.open("GET", page.url, true);
	req.send(null);
}


// This function caches a download
function puc_writeBasedOnID(data, id) {
	var foStream = puc_getWriteStream(id);
	foStream.write(data, data.length);
	foStream.close();
}


// Asynchronous file read code borrowed from http://kb.mozillazine.org/File_IO
function puc_compareOldWithNew(page, newData) {

	var file = puc_getFile(page.id);
	
	var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var fileURI = ios.newFileURI(file);
	var channel = ios.newChannelFromURI(fileURI);

	var observer = {
	  onStreamComplete : function(aLoader, aContext, aStatus, aLength, oldText)
	  {

		// ***** THE ACTUAL COMPARRISON *****
		// (This would be the place to start if you want to do fancier comparrisons)

		if(oldText == newData) {
			puc_logMessage("No change found in " + page.url);
			if(PrefUtils.getPref("puc.notifydespiteupdate"))
				alert("Page Update Checker:\nNo change found in " + page.url+
				      "\n(To remove this message, go \n'Tools' -> 'Page Update Checker Options' -> 'Preferences')");
		} else {

			puc_logMessage(page.url + " changed.");

			// Tell the user that the website changed:
			
			// "pucNotify"+page.id assures that strictly one window comes up for a given page,
 			// So if the user accidentally has the page update every 5 seconds and they leave
			// this running, they won't come back to find a million boxes open.


			// First, see if this notification is already being displayed
			var isOpen = false;

			// Scan through Firefox windows
			var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			var enumerator = wm.getEnumerator(""); // "" tells to look at ALL window types
			while(enumerator.hasMoreElements()) {
				var win = enumerator.getNext();
				if(win.name == "pucNotify"+page.id)
					isOpen = true;
			}

			if( !isOpen )
				window.openDialog("chrome://puc/content/pucNotify.xul", "pucNotify"+page.id, 
					"centerscreen", page.url, page.title); 

			
			// Save new version
			puc_writeBasedOnID(newData, page.id);
		}
	  }
	};
	var sl = Components.classes["@mozilla.org/network/stream-loader;1"]
		.createInstance(Components.interfaces.nsIStreamLoader);
	sl.init(channel, observer, null);
	
}


function  pucDoOptions()
{
    window.openDialog("chrome://puc/content/pucOptions.xul", "pucOptions", "centerscreen,modal");
}


function puc_logMessage(logString)
{
        aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);

    	if(aConsoleService)
	    	aConsoleService.logStringMessage("PUC: " + logString);
}
